/'
 ' Project Publisher - Installer Creator Addin for FbEdit, RadASM and MasmEdit
 '
 ' Copyright (C) 2010 Arnel A. Borja (Galeon)
 '
 ' This program is free software: you can redistribute it and/or modify it under 
 ' the terms of the GNU General Public License as published by the Free Software 
 ' Foundation, either version 3 of the License, or (at your option) any later 
 ' version.
 '
 ' This program is distributed in the hope that it will be useful, but WITHOUT 
 ' ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 ' FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more 
 ' details.
 '
 ' You should have received a copy of the GNU General Public License along with 
 ' this program.  If not, see <http://www.gnu.org/licenses/>.
 '
 '/

#Include Once "windows.bi"
#Include Once "win/commctrl.bi"
#Include Once "win/shellapi.bi"

#Include Once "Inc/FbEdit.bi"
#Include Once "Inc/RadASM2.bi"
#Include Once "Inc/RadASM3.bi"
#Include Once "Inc/MasmEd.bi"

#Include Once "ProjPub.bi"
#Include Once "Settings.bi"
#Include Once "Help.bi"
#Include Once "CustomUI.bi"
#Include Once "Resource.bi"

Function CustomUIGlobalDialogProc( _
	ByVal hWin As HWND, _
	ByVal uMsg As UINT, _
	ByVal wParam As WPARAM, _
	ByVal lParam As LPARAM _
	) As BOOL

	Select Case uMsg
		Case WM_INITDIALOG
			' Translate dialog box
			TranslateAddinDialog( hWin )

			' Limit text
         SendDlgItemMessage( hWin, IDC_EDTCUSTOMUIWIZARDINST, EM_SETLIMITTEXT, Cast( LPARAM, MAX_PATH ), 0 )
         SendDlgItemMessage( hWin, IDC_EDTCUSTOMUIWIZARDUNINST, EM_SETLIMITTEXT, Cast( LPARAM, MAX_PATH ), 0 )
         SendDlgItemMessage( hWin, IDC_EDTCUSTOMUIICONINST, EM_SETLIMITTEXT, Cast( LPARAM, MAX_PATH ), 0 )
         SendDlgItemMessage( hWin, IDC_EDTCUSTOMUIICONUNINST, EM_SETLIMITTEXT, Cast( LPARAM, MAX_PATH ), 0 )
         SendDlgItemMessage( hWin, IDC_EDTCUSTOMUIHEADERINST, EM_SETLIMITTEXT, Cast( LPARAM, MAX_PATH ), 0 )
         SendDlgItemMessage( hWin, IDC_EDTCUSTOMUIHEADERINSTR, EM_SETLIMITTEXT, Cast( LPARAM, MAX_PATH ), 0 )
         SendDlgItemMessage( hWin, IDC_EDTCUSTOMUIHEADERUNINST, EM_SETLIMITTEXT, Cast( LPARAM, MAX_PATH ), 0 )
         SendDlgItemMessage( hWin, IDC_EDTCUSTOMUIHEADERUNINSTR, EM_SETLIMITTEXT, Cast( LPARAM, MAX_PATH ), 0 )

			' Set values
			SetDlgItemText( hWin, IDC_EDTCUSTOMUIWIZARDINST, @GlobalSettings.WizardInstall )
			SetDlgItemText( hWin, IDC_EDTCUSTOMUIWIZARDUNINST, @GlobalSettings.WizardUninstall )
			SetDlgItemText( hWin, IDC_EDTCUSTOMUIICONINST, @GlobalSettings.IconInstall )
			SetDlgItemText( hWin, IDC_EDTCUSTOMUIICONUNINST, @GlobalSettings.IconUninstall )
			SetDlgItemText( hWin, IDC_EDTCUSTOMUIHEADERINST, @GlobalSettings.HeaderInstall )
			SetDlgItemText( hWin, IDC_EDTCUSTOMUIHEADERINSTR, @GlobalSettings.HeaderInstallRight )
			SetDlgItemText( hWin, IDC_EDTCUSTOMUIHEADERUNINST, @GlobalSettings.HeaderUninstall )
			SetDlgItemText( hWin, IDC_EDTCUSTOMUIHEADERUNINSTR, @GlobalSettings.HeaderUninstallRight )

			'
		Case WM_COMMAND
			Select Case LoWord( wParam )
				Case IDCANCEL
					EndDialog( hWin, 0 )
					'
				Case IDOK
					GetDlgItemText( hWin, IDC_EDTCUSTOMUIWIZARDINST, @GlobalSettings.WizardInstall, MAX_PATH )
					GetDlgItemText( hWin, IDC_EDTCUSTOMUIWIZARDUNINST, @GlobalSettings.WizardUninstall, MAX_PATH )
					GetDlgItemText( hWin, IDC_EDTCUSTOMUIICONINST, @GlobalSettings.IconInstall, MAX_PATH )
					GetDlgItemText( hWin, IDC_EDTCUSTOMUIICONUNINST, @GlobalSettings.IconUninstall, MAX_PATH )
					GetDlgItemText( hWin, IDC_EDTCUSTOMUIHEADERINST, @GlobalSettings.HeaderInstall, MAX_PATH )
					GetDlgItemText( hWin, IDC_EDTCUSTOMUIHEADERINSTR, @GlobalSettings.HeaderInstallRight, MAX_PATH )
					GetDlgItemText( hWin, IDC_EDTCUSTOMUIHEADERUNINST, @GlobalSettings.HeaderUninstall, MAX_PATH )
					GetDlgItemText( hWin, IDC_EDTCUSTOMUIHEADERUNINSTR, @GlobalSettings.HeaderUninstallRight, MAX_PATH )
					EndDialog( hWin, 1 )
					'
				Case IDC_BTNCUSTOMUIWIZARDINST
					If GlobalSettings.WizardInstall <> "" Then
						buffer = GlobalSettings.WizardInstall
					Else
						buffer = IDEPath
					End If
					Dim FilePath As String = OpenFileName( _
						hWin, _
						GetTranslateString( "6013", "Select Bitmap File" ), _
						buffer, _
						!"Bitmap Files (*.bmp)\0*.bmp\0" _
						)
					If FilePath <> "" Then _
						SetDlgItemText( hWin, IDC_EDTCUSTOMUIWIZARDINST, FilePath )
					'
				Case IDC_BTNCUSTOMUIWIZARDUNINST
					If GlobalSettings.WizardUninstall <> "" Then
						buffer = GlobalSettings.WizardUninstall
					Else
						buffer = IDEPath
					End If
					Dim FilePath As String = OpenFileName( _
						hWin, _
						GetTranslateString( "6013", "Select Bitmap File" ), _
						buffer, _
						!"Bitmap Files (*.bmp)\0*.bmp\0" _
						)
					If FilePath <> "" Then _
						SetDlgItemText( hWin, IDC_EDTCUSTOMUIWIZARDUNINST, FilePath )
					'
				Case IDC_BTNCUSTOMUIICONINST
					If GlobalSettings.IconInstall <> "" Then
						buffer = GlobalSettings.IconInstall
					Else
						buffer = IDEPath
					End If
					Dim FilePath As String = OpenFileName( _
						hWin, _
						GetTranslateString( "6014", "Select Icon File" ), _
						buffer, _
						!"Icon Files (*.ico)\0*.ico\0" _
						)
					If FilePath <> "" Then _
						SetDlgItemText( hWin, IDC_EDTCUSTOMUIICONINST, FilePath )
					'
				Case IDC_BTNCUSTOMUIICONUNINST
					If GlobalSettings.IconUninstall <> "" Then
						buffer = GlobalSettings.IconUninstall
					Else
						buffer = IDEPath
					End If
					Dim FilePath As String = OpenFileName( _
						hWin, _
						GetTranslateString( "6014", "Select Icon File" ), _
						buffer, _
						!"Icon Files (*.ico)\0*.ico\0" _
						)
					If FilePath <> "" Then _
						SetDlgItemText( hWin, IDC_EDTCUSTOMUIICONUNINST, FilePath )
					'
				Case IDC_BTNCUSTOMUIHEADERINST
					If GlobalSettings.HeaderInstall <> "" Then
						buffer = GlobalSettings.HeaderInstall
					Else
						buffer = IDEPath
					End If
					Dim FilePath As String = OpenFileName( _
						hWin, _
						GetTranslateString( "6013", "Select Bitmap File" ), _
						buffer, _
						!"Bitmap Files (*.bmp)\0*.bmp\0" _
						)
					If FilePath <> "" Then _
						SetDlgItemText( hWin, IDC_EDTCUSTOMUIHEADERINST, FilePath )
					'
				Case IDC_BTNCUSTOMUIHEADERUNINST
					If GlobalSettings.HeaderUninstall <> "" Then
						buffer = GlobalSettings.HeaderUninstall
					Else
						buffer = IDEPath
					End If
					Dim FilePath As String = OpenFileName( _
						hWin, _
						GetTranslateString( "6013", "Select Bitmap File" ), _
						buffer, _
						!"Bitmap Files (*.bmp)\0*.bmp\0" _
						)
					If FilePath <> "" Then _
						SetDlgItemText( hWin, IDC_EDTCUSTOMUIHEADERUNINST, FilePath )
					'
				Case IDC_BTNCUSTOMUIHEADERINSTR
					If GlobalSettings.HeaderInstallRight <> "" Then
						buffer = GlobalSettings.HeaderInstallRight
					Else
						buffer = IDEPath
					End If
					Dim FilePath As String = OpenFileName( _
						hWin, _
						GetTranslateString( "6013", "Select Bitmap File" ), _
						buffer, _
						!"Bitmap Files (*.bmp)\0*.bmp\0" _
						)
					If FilePath <> "" Then _
						SetDlgItemText( hWin, IDC_EDTCUSTOMUIHEADERINSTR, FilePath )
					'
				Case IDC_BTNCUSTOMUIHEADERUNINSTR
					If GlobalSettings.HeaderUninstallRight <> "" Then
						buffer = GlobalSettings.HeaderUninstallRight
					Else
						buffer = IDEPath
					End If
					Dim FilePath As String = OpenFileName( _
						hWin, _
						GetTranslateString( "6013", "Select Bitmap File" ), _
						buffer, _
						!"Bitmap Files (*.bmp)\0*.bmp\0" _
						)
					If FilePath <> "" Then _
						SetDlgItemText( hWin, IDC_EDTCUSTOMUIHEADERUNINSTR, FilePath )
					'
			End Select
			'
		Case WM_CLOSE
			EndDialog( hWin, 0 )
			'
		Case WM_HELP
			ShowContextHelp( Cast( HELPINFO Ptr, lParam ) )
			'
		Case Else
			Return FALSE
			'
	End Select

	Return TRUE

End Function


Function CustomUIProjectDialogProc( _
	ByVal hWin As HWND, _
	ByVal uMsg As UINT, _
	ByVal wParam As WPARAM, _
	ByVal lParam As LPARAM _
	) As BOOL

	Select Case uMsg
		Case WM_INITDIALOG
			' Translate dialog box
			TranslateAddinDialog( hWin )

			' Limit text
         SendDlgItemMessage( hWin, IDC_EDTCUSTOMUIWIZARDINST, EM_SETLIMITTEXT, Cast( LPARAM, MAX_PATH ), 0 )
         SendDlgItemMessage( hWin, IDC_EDTCUSTOMUIWIZARDUNINST, EM_SETLIMITTEXT, Cast( LPARAM, MAX_PATH ), 0 )
         SendDlgItemMessage( hWin, IDC_EDTCUSTOMUIICONINST, EM_SETLIMITTEXT, Cast( LPARAM, MAX_PATH ), 0 )
         SendDlgItemMessage( hWin, IDC_EDTCUSTOMUIICONUNINST, EM_SETLIMITTEXT, Cast( LPARAM, MAX_PATH ), 0 )
         SendDlgItemMessage( hWin, IDC_EDTCUSTOMUIHEADERINST, EM_SETLIMITTEXT, Cast( LPARAM, MAX_PATH ), 0 )
         SendDlgItemMessage( hWin, IDC_EDTCUSTOMUIHEADERINSTR, EM_SETLIMITTEXT, Cast( LPARAM, MAX_PATH ), 0 )
         SendDlgItemMessage( hWin, IDC_EDTCUSTOMUIHEADERUNINST, EM_SETLIMITTEXT, Cast( LPARAM, MAX_PATH ), 0 )
         SendDlgItemMessage( hWin, IDC_EDTCUSTOMUIHEADERUNINSTR, EM_SETLIMITTEXT, Cast( LPARAM, MAX_PATH ), 0 )

			' Set values
			SetDlgItemText( hWin, IDC_EDTCUSTOMUIWIZARDINST, @ProjectSettings.WizardInstall )
			SetDlgItemText( hWin, IDC_EDTCUSTOMUIWIZARDUNINST, @ProjectSettings.WizardUninstall )
			SetDlgItemText( hWin, IDC_EDTCUSTOMUIICONINST, @ProjectSettings.IconInstall )
			SetDlgItemText( hWin, IDC_EDTCUSTOMUIICONUNINST, @ProjectSettings.IconUninstall )
			SetDlgItemText( hWin, IDC_EDTCUSTOMUIHEADERINST, @ProjectSettings.HeaderInstall )
			SetDlgItemText( hWin, IDC_EDTCUSTOMUIHEADERINSTR, @ProjectSettings.HeaderInstallRight )
			SetDlgItemText( hWin, IDC_EDTCUSTOMUIHEADERUNINST, @ProjectSettings.HeaderUninstall )
			SetDlgItemText( hWin, IDC_EDTCUSTOMUIHEADERUNINSTR, @ProjectSettings.HeaderUninstallRight )

			'
		Case WM_COMMAND
			Select Case LoWord( wParam )
				Case IDCANCEL
					EndDialog( hWin, 0 )
					'
				Case IDOK
					GetDlgItemText( hWin, IDC_EDTCUSTOMUIWIZARDINST, @ProjectSettings.WizardInstall, MAX_PATH )
					GetDlgItemText( hWin, IDC_EDTCUSTOMUIWIZARDUNINST, @ProjectSettings.WizardUninstall, MAX_PATH )
					GetDlgItemText( hWin, IDC_EDTCUSTOMUIICONINST, @ProjectSettings.IconInstall, MAX_PATH )
					GetDlgItemText( hWin, IDC_EDTCUSTOMUIICONUNINST, @ProjectSettings.IconUninstall, MAX_PATH )
					GetDlgItemText( hWin, IDC_EDTCUSTOMUIHEADERINST, @ProjectSettings.HeaderInstall, MAX_PATH )
					GetDlgItemText( hWin, IDC_EDTCUSTOMUIHEADERINSTR, @ProjectSettings.HeaderInstallRight, MAX_PATH )
					GetDlgItemText( hWin, IDC_EDTCUSTOMUIHEADERUNINST, @ProjectSettings.HeaderUninstall, MAX_PATH )
					GetDlgItemText( hWin, IDC_EDTCUSTOMUIHEADERUNINSTR, @ProjectSettings.HeaderUninstallRight, MAX_PATH )
					EndDialog( hWin, 1 )
					'
				Case IDC_BTNCUSTOMUIWIZARDINST
					If ProjectSettings.WizardInstall <> "" Then
						buffer = ProjectSettings.WizardInstall
					Else
						buffer = CurProjectPath
					End If
					Dim FilePath As String = OpenFileName( _
						hWin, _
						GetTranslateString( "6013", "Select Bitmap File" ), _
						buffer, _
						!"Bitmap Files (*.bmp)\0*.bmp\0" _
						)
					If FilePath <> "" Then _
						SetDlgItemText( hWin, IDC_EDTCUSTOMUIWIZARDINST, FilePath )
					'
				Case IDC_BTNCUSTOMUIWIZARDUNINST
					If ProjectSettings.WizardUninstall <> "" Then
						buffer = ProjectSettings.WizardUninstall
					Else
						buffer = CurProjectPath
					End If
					Dim FilePath As String = OpenFileName( _
						hWin, _
						GetTranslateString( "6013", "Select Bitmap File" ), _
						buffer, _
						!"Bitmap Files (*.bmp)\0*.bmp\0" _
						)
					If FilePath <> "" Then _
						SetDlgItemText( hWin, IDC_EDTCUSTOMUIWIZARDUNINST, FilePath )
					'
				Case IDC_BTNCUSTOMUIICONINST
					If ProjectSettings.IconInstall <> "" Then
						buffer = ProjectSettings.IconInstall
					Else
						buffer = CurProjectPath
					End If
					Dim FilePath As String = OpenFileName( _
						hWin, _
						GetTranslateString( "6014", "Select Icon File" ), _
						buffer, _
						!"Icon Files (*.ico)\0*.ico\0" _
						)
					If FilePath <> "" Then _
						SetDlgItemText( hWin, IDC_EDTCUSTOMUIICONINST, FilePath )
					'
				Case IDC_BTNCUSTOMUIICONUNINST
					If ProjectSettings.IconUninstall <> "" Then
						buffer = ProjectSettings.IconUninstall
					Else
						buffer = CurProjectPath
					End If
					Dim FilePath As String = OpenFileName( _
						hWin, _
						GetTranslateString( "6014", "Select Icon File" ), _
						buffer, _
						!"Icon Files (*.ico)\0*.ico\0" _
						)
					If FilePath <> "" Then _
						SetDlgItemText( hWin, IDC_EDTCUSTOMUIICONUNINST, FilePath )
					'
				Case IDC_BTNCUSTOMUIHEADERINST
					If ProjectSettings.HeaderInstall <> "" Then
						buffer = ProjectSettings.HeaderInstall
					Else
						buffer = CurProjectPath
					End If
					Dim FilePath As String = OpenFileName( _
						hWin, _
						GetTranslateString( "6013", "Select Bitmap File" ), _
						buffer, _
						!"Bitmap Files (*.bmp)\0*.bmp\0" _
						)
					If FilePath <> "" Then _
						SetDlgItemText( hWin, IDC_EDTCUSTOMUIHEADERINST, FilePath )
					'
				Case IDC_BTNCUSTOMUIHEADERUNINST
					If ProjectSettings.HeaderUninstall <> "" Then
						buffer = ProjectSettings.HeaderUninstall
					Else
						buffer = CurProjectPath
					End If
					Dim FilePath As String = OpenFileName( _
						hWin, _
						GetTranslateString( "6013", "Select Bitmap File" ), _
						buffer, _
						!"Bitmap Files (*.bmp)\0*.bmp\0" _
						)
					If FilePath <> "" Then _
						SetDlgItemText( hWin, IDC_EDTCUSTOMUIHEADERUNINST, FilePath )
					'
				Case IDC_BTNCUSTOMUIHEADERINSTR
					If ProjectSettings.HeaderInstallRight <> "" Then
						buffer = ProjectSettings.HeaderInstallRight
					Else
						buffer = CurProjectPath
					End If
					Dim FilePath As String = OpenFileName( _
						hWin, _
						GetTranslateString( "6013", "Select Bitmap File" ), _
						buffer, _
						!"Bitmap Files (*.bmp)\0*.bmp\0" _
						)
					If FilePath <> "" Then _
						SetDlgItemText( hWin, IDC_EDTCUSTOMUIHEADERINSTR, FilePath )
					'
				Case IDC_BTNCUSTOMUIHEADERUNINSTR
					If ProjectSettings.HeaderUninstallRight <> "" Then
						buffer = ProjectSettings.HeaderUninstallRight
					Else
						buffer = CurProjectPath
					End If
					Dim FilePath As String = OpenFileName( _
						hWin, _
						GetTranslateString( "6013", "Select Bitmap File" ), _
						buffer, _
						!"Bitmap Files (*.bmp)\0*.bmp\0" _
						)
					If FilePath <> "" Then _
						SetDlgItemText( hWin, IDC_EDTCUSTOMUIHEADERUNINSTR, FilePath )
					'
			End Select
			'
		Case WM_CLOSE
			EndDialog( hWin, 0 )
			'
		Case WM_HELP
			ShowContextHelp( Cast( HELPINFO Ptr, lParam ) )
			'
		Case Else
			Return FALSE
			'
	End Select

	Return TRUE

End Function


