' include file for building RadASM plugins

#define RadASM2_Version		2208

' Assemblers
#define RA2ASM_MASM					1
#define RA2ASM_TASM					2
#define RA2ASM_FASM					3
#define RA2ASM_GOASM					4
#define RA2ASM_NASM					5
#define RA2ASM_HLA					6
#define RA2ASM_CPP					7						' C/C++
#define RA2ASM_BCET					8						' BCET and FreeBASIC
#define RA2ASM_OTHER					99

' Messages to RadASM's mdi frame
#define RA2AIM_GETHANDLES			WM_USER+50			' returns a poiner to a struct containing all useful handles:see structures below
#define RA2AIM_GETPROCS				WM_USER+51			' returns a poiner to a struct containing some procs in RadASM:see structures below
#define RA2AIM_GETDATA				WM_USER+52			' returns a poiner to a struct comtaining data pointers:see structures below
#define RA2AIM_GETMENUID			WM_USER+53			' Returns a free menu id. If you need more than one just send the message again.

' Messages from RadASM to DllProc procedure
' Hook flag in eax
#define RA2AIM_COMMAND				WM_COMMAND			' hWnd=Handle of mdi frame, wParam & lParam=as for WM_COMMAND
#define RA2AIM_MAKEBEGIN			WM_USER+100			' hWnd=Handle of mdi frame, wParam=0, lParam=pointer to string containing commands
#define RA2AIM_MAKEDONE				WM_USER+101			' hWnd=Handle of mdi frame, wParam=0, lParam=exit code
#define RA2AIM_CLOSE					WM_CLOSE				' hWnd=Handle of mdi frame, wParam & lParam=as for WM_CLOSE
#define RA2AIM_INITMENUPOPUP		WM_INITMENUPOPUP	' hWnd=Handle of mdi frame, wParam & lParam=as for WM_INITMENUPOPUP
#define RA2AIM_COMMANDDONE			WM_USER+102			' hWnd=Handle of mdi frame, wParam & lParam=as for WM_COMMAND
#define RA2AIM_PROJECTCLOSE		WM_USER+103			' hWnd=Handle of mdi frame, wParam=0, lParam=0
#define RA2AIM_PROJECTCLOSED		WM_USER+104			' hWnd=Handle of mdi frame, wParam=0, lParam=0
#define RA2AIM_CLIENTMOUSEMOVE	WM_USER+105			' hWnd=handle of client, wParam & lParam=as for WM_MOUSEMOVE
#define RA2AIM_TIMER					WM_USER+106			' as for a TimerProc
#define RA2AIM_CTLDBLCLK			WM_USER+107			' hWnd=handle of mdi child, wParam=handle of control, lParam=pointer to DIALOG structure
#define RA2AIM_CREATENEWDLG		WM_USER+108			' hWnd=handle of mdi child, wParam=handle of dialog, lParam=pointer to filename
#define RA2AIM_CONTEXTMENU			WM_USER+109			' hWnd=Handle of mdi frame, wParam & lParam=as for WM_CONTEXTMENU
#define RA2AIM_PROJECTOPENED		WM_USER+110			' hWnd=handle of mdi frame, wParam=0, lParam=pointer to filename
#define RA2AIM_MENUREBUILD			WM_USER+111			' hWnd=handle of menu, wParam=0, lParam=0
#define RA2AIM_EDITOPEN				WM_USER+112			' hWnd=handle of mdi child, wParam=handle of edit, lParam=ID_EDIT or ID_EDITTXT
#define RA2AIM_EDITCLOSE			WM_USER+113			' hWnd=handle of mdi child, wParam=handle of edit, lParam=ID_EDIT or ID_EDITTXT
#define RA2AIM_EDITCLOSED			WM_USER+114			' hWnd=handle of mdi child, wParam=handle of edit, lParam=ID_EDIT or ID_EDITTXT
#define RA2AIM_EDITSAVE				WM_USER+115			' hWnd=handle of mdi child, wParam=handle of edit, lParam=pointer to filename
#define RA2AIM_EDITSAVED			WM_USER+116			' hWnd=handle of mdi child, wParam=handle of edit, lParam=pointer to filename
#define RA2AIM_TBRTOOLTIP			WM_USER+117			' hWnd=handle of mdi frame, wParam=ID, lParam=0
#define RA2AIM_MDIACTIVATE			WM_USER+118			' hWnd=handle of mdi child, wParam & lParam=same as for WM_MDIACTIVATE
#define RA2AIM_EDITSELCHANGE		WM_USER+119			' hWnd=handle of mdi child, wParam=handle of edit, lParam=ID
#define RA2AIM_PROJECTADDNEW		WM_USER+120			' hWnd=handle of mdi frame, wParam=type, lParam=pointer to filename
#define RA2AIM_PROJECTREMOVE		WM_USER+121			' hWnd=handle of mdi frame, wParam=0, lParam=pointer to filename
#define RA2AIM_DLGMNUSELECT		WM_USER+122			' hWnd=handle of mdi child, wParam=handle of dialog, lParam=pointer to MENUITEM structure
#define RA2AIM_RCUPDATE				WM_USER+123			' hWnd=handle of dialog,wParam=type,lParam=pointer to memory
#define RA2AIM_CREATENEWCTL		WM_USER+124			' hWnd=handle of mdi child, wParam=handle of dialog, lParam=pointer to DIALOG structure
#define RA2AIM_TOOLSHOW				WM_USER+125			' hWnd=handle of tool,wParam=visible,lParam=ID
#define RA2AIM_SETSTYLE				WM_USER+126			' hWnd=handle of property listbox, wParam=Pointer to DIALOG struct. lParam=TRUE if ExStyle
#define RA2AIM_OUTPUTDBLCLK		WM_USER+127			' hWnd=handle of output, wParam & lParam=same as for WM_LBUTTONDBLCLK
#define RA2AIM_CODEINFO				WM_USER+128			' hWnd=handle of mdi child, wParam=ID, lParam=pointer to word
' Hook flag in ecx
#define RA2AIM_MODULEBUILD			WM_USER+129			' hWnd=handle of mdi frame,wParam=lpFileName(no ext), lParam=0
#define RA2AIM_DIALOGOPEN			WM_USER+130			' hWnd=handle of mdi child,wParam=lpDlgMem, lParam=0
#define RA2AIM_DIALOGSAVE			WM_USER+131			' hWnd=handle of mdi child,wParam=hFile, lParam=0
#define RA2AIM_UNHOOK				WM_USER+132			' hWnd=handle of window to unhook,wParam=proc to unhook, lParam=previous proc
#define RA2AIM_ADDINSLOADED		WM_USER+133			' hWnd=handle of mdi frame,wParam=0, lParam=0
#define RA2AIM_LANGUAGECHANGE		WM_USER+134			' hWnd=handle of mdi frame,wParam=0, lParam=0
#define RA2AIM_PROJECTOPEN			WM_USER+135			' hWnd=handle of mdi frame, wParam=0, lParam=pointer to filename
#define RA2AIM_PROJECTRENAME		WM_USER+136			' hWnd=handle of mdi frame, wParam=pointer to old filename, lParam=pointer to new filename
#define RA2AIM_EDITKEYDOWN			WM_USER+137			' hWnd=handle of edit window, wParam and lParam as WM_KEYDOWN
#define RA2AIM_EDITCHAR				WM_USER+138			' hWnd=handle of edit window, wParam and lParam as WM_CHAR
#define RA2AIM_PREPARSE				WM_USER+139			' hWnd=handle of mdi frame, wParam=project file number,lParam=pointer to file content
#define RA2AIM_PARSEDONE			WM_USER+140			' hWnd=handle of mdi frame, wParam=project file number,lParam=pointer to file content

' Return values in fHook1 (0 to 31) from InstallDll procedure which tell RadASM which messages to send to your DllProc procedure,can be OR'ed
#define RA2AIH_COMMAND				&H00000001			' RAAIM_COOMAND equ WM_COMMAND
#define RA2AIH_COMMANDDONE			&H00000002			' RAAIM_COMMANDDONE
#define RA2AIH_CLOSE					&H00000004			' RAAIM_CLOSE equ WM_CLOSE			
#define RA2AIH_INITMENUPOPUP		&H00000008			' RAAIM_INITMENUPOPUP equ WM_INITMENUPOPUP	
#define RA2AIH_MAKEBEGIN			&H00000010			' RAAIM_MAKEBEGIN		
#define RA2AIH_MAKEDONE				&H00000020			' RAAIM_MAKEDONE		
#define RA2AIH_PROJECTCLOSE		&H00000040			' RAAIM_PROJECTCLOSE	
#define RA2AIH_PROJECTCLOSED		&H00000080			' RAAIM_PROJECTCLOSED
#define RA2AIH_CLIENTMOUSEMOVE	&H00000100			' RAAIM_CLIENTMOUSEMOVE 
#define RA2AIH_TIMER					&H00000200			' RAAIM_TIMER			
#define RA2AIH_CTLDBLCLK			&H00000400			' RAAIM_CTLDBLCLK		
#define RA2AIH_CREATENEWDLG		&H00000800			' RAAIM_CREATENEWDLG	
#define RA2AIH_CONTEXTMENU			&H00001000			' RAAIM_CONTEXTMENU	    
#define RA2AIH_PROJECTOPENED		&H00002000			' RAAIM_PROJECTOPENED
#define RA2AIH_MENUREBUILD			&H00004000			' RAAIM_MENUREBUILD
#define RA2AIH_EDITOPEN				&H00008000			' RAAIM_EDITOPEN
#define RA2AIH_EDITCLOSE			&H00010000			' RAAIM_EDITCLOSE
#define RA2AIH_EDITCLOSED			&H00020000			' RAAIM_EDITCLOSED
#define RA2AIH_EDITSAVE				&H00040000			' RAAIM_EDITSAVE
#define RA2AIH_EDITSAVED			&H00080000			' RAAIM_EDITSAVED
#define RA2AIH_TBRTOOLTIP			&H00100000			' RAAIM_TBRTOOLTIP
#define RA2AIH_MDIACTIVATE			&H00200000			' RAAIM_MDIACTIVATE
#define RA2AIH_EDITSELCHANGE		&H00400000			' RAAIM_EDITSELCHANGE
#define RA2AIH_PROJECTADDNEW		&H00800000			' RAAIM_PROJECTADDNEW
#define RA2AIH_PROJECTREMOVE		&H01000000			' RAAIM_PROJECTREMOVE
#define RA2AIH_DLGMNUSELECT		&H02000000			' RAAIM_DLGMNUSELECT
#define RA2AIH_RCUPDATE				&H04000000			' RAAIM_RCUPDATE
#define RA2AIH_CREATENEWCTL		&H08000000			' RAAIM_CREATENEWCTL
#define RA2AIH_TOOLSHOW				&H10000000			' RAAIM_TOOLSHOW
#define RA2AIH_SETSTYLE				&H20000000			' RAAIM_SETSTYLE
#define RA2AIH_OUTPUTDBLCLK		&H40000000			' RAAIM_OUTPUTDBLCLK
#define RA2AIH_CODEINFO				&H80000000			' RAAIM_CODEINFO

' Return values in fHook2 (32 to 63) from InstallDll procedure which tell RadASM which messages to send to your DllProc procedure,can be OR'ed
#define RA2AIH_MODULEBUILD			&H00000001			' RAAIM_MODULEBUILD
#define RA2AIH_DIALOGOPEN			&H00000002			' RAAIM_DIALOGOPEN
#define RA2AIH_DIALOGSAVE			&H00000004			' RAAIM_DIALOGSAVE
#define RA2AIH_UNHOOK				&H00000008			' RAAIM_UNHOOK
#define RA2AIH_ADDINSLOADED		&H00000010			' RAAIM_ADDINSLOADED
#define RA2AIH_LANGUAGECHANGE		&H00000020			' RAAIM_LANGUAGECHANGE
#define RA2AIH_PROJECTOPEN			&H00000040			' RAAIM_PROJECTOPEN
#define RA2AIH_PROJECTRENAME		&H00000080			' RAAIM_PROJECTRENAME
#define RA2AIH_EDITKEYDOWN			&H00000100			' RAAIM_EDITKEYDOWN
#define RA2AIH_EDITCHAR				&H00000200			' RAAIM_EDITCHAR
#define RA2AIH_PREPARSE				&H00000400			' RAAIM_PREPARSE
#define RA2AIH_PARSEDONE			&H00000800			' RAAIM_PARSEDONE

' Structure pointed to on return from RAAIM_GETHANDLES 
type RA2ADDINHANDLES field=1
	hWnd									As HWND				' Handle of mdi Frame
	hMenu									As HMENU				' Handle of mdi Frame Menu
	hToolBar								As HWND				' Handle of mdi Frame ToolBar
	hStatus								As HWND				' Handle of mdi Frame StatusBar
	hClient								As HWND				' Handle of mdi client
	hMdiCld								As HWND				' Handle of topmost mdi Child window
	hEdit									As HWND				' Handle of topmost mdi Child RAEdit window
	hDialog								As HWND				' Handle of topmost mdi Child DialogBox window
	hSearch								As HWND				' Handle of search / replace dialog
	hGoTo									As HWND				' Handle of goto dialog
	hOut									As HWND				' Handle of output Static container
	hPbr									As HWND				' Handle of project Static container
	hTlb									As HWND				' Handle of toolbox Static container
	hPrp									As HWND				' Handle of properties Static container
	hPrpCbo								As HWND				' Handle of properties ComboBox
	hPrpLst								As HWND				' Handle of properties ListBox
	hPrpTxt								As HWND				' Handle of properties item Edit control
	hTxtLst								As HWND				' Handle of properties item ListBox
	hTxtBtn								As HWND				' Handle of properties item Button
	hLB									As HWND				' Handle of Api ListBox (CodeComplete). Same as hLBU or hLBS
	hTlt									As HWND				' Handle of Api Static (ToolTip)
	hInst									As HINSTANCE		' RadASM instance
	hToolMenu							As HMENU				' Handle of RightClick Menu in project, properties and output window
	hTab									As HWND				' Handle of tab window
	hPbrTrv								As HWND				' Handle of project browser TreeView
	hPrpTbr								As HWND				' Handle of properties ToolBar
	hPbrTbr								As HWND				' Handle of project / file browser ToolBar
	hFileTrv								As HWND				' Handle of file browser TreeView
	hOutREd								As HWND				' Handle of active output RAEdit window
	hOut1									As HWND				' Handle of output#1 RAEdit window
	hOut2									As HWND				' Handle of output#2 RAEdit window
	hOut3									As HWND				' Handle of output#3 RAEdit window
	hOutBtn1								As HWND				' Handle of output button #1
	hOutBtn2								As HWND				' Handle of output button #2
	hOutBtn3								As HWND				' Handle of output button #3
	hDivider								As HWND				' Handle of divider line
	hSniplet								As HWND				' Handle of sniplet dialog
	hToolTip								As HWND				' Handle of toolbox button tooltip
	hLBU									As HWND				' Handle of unsorted listbox
	hLBS									As HWND				' Handle of sorted listbox
	hInf									As HWND				' Handle of infotool static container
	hInfEdt								As HWND				' Handle of infotool edit control
	hTl1									As HWND				' Handle of tool#1 static container
	hTl2									As HWND				' Handle of tool#2 static container
	hHexEd								As HWND				' Handle of topmost mdi Child RAHexEd window
	hAccel								As HACCEL			' RadASM Accelerators
	hTbrIml								As HIMAGELIST		' Imagelist for the toolbars
	hTypeIml								As HIMAGELIST		' Imagelist for the intellisense listboxes
	hPrpTxtMulti						As HWND				' Handle of properties item multiline Edit control
	hLBFont								As HFONT				' Api listboxes
	hTTFont								As HFONT				' Api tooltip
	hFont(3)				 				As HFONT				' Code edit Normal, Italic, Linenumber
	hFontTxt								As HFONT				' Text edit
	hFontHex								As HFONT				' Hex edit
	hFullScreen							As HWND				' Handle of fullscreen editing popup
end type

' Structure pointed to on return from RAAIM_GETPROCS
type RA2ADDINPROCS field=1
	lpTextOut							As long				' Pointer to proc handeling text to output window. Push pointer to text before calling.
	lpHexOut								As long				' Pointer to proc handeling hex to output window. Use for debug. Push val before calling.
	lpClearOut							As long				' Pointer to proc clearing output
	lpAddProjectFile					As long				' lpFileName,fUpdateTree,fModule
	lpOpenProjectFile					As long				' Give error msg TRUE/FALSE, set lpFile to file to open
	lpToolMessage						As long				' Handle, message, lParam
	lpGetWordFromPos					As long				' Handle of RAEdit, returns pointer to word
	lpProFind							As long				' Pointer to a PROFIND struct
	lpGetWord							As long				' lpWord, returns pointer to word
	lpRemoveProjectPath				As long				' lpFileName, lpBuff, returns pointer to filename
	lpGetMainFile						As long				' lpFileExt
	lpSearchMem							As long				' hMem,lpFind,fMCase,fWWord
	lpProScan							As long				' lpFind,lpNot
	lpBackupEdit						As long				' lpFileName,1
	lpGetFileType						As long				' lpFileName
	lpOutputSelect						As long				' (1,2 or 3)
	lpUpdateCtl							As long				' Handle of control
	lpShowBreakPoint					As long				' Breakpoint ID (0-255)
	lpUpdateVerInf						As long				' TRUE to export to output, FALSE to update rc file
	lpCloseProject						As long				' No parameters
	lpOpenProject						As long				' Parameter TRUE/FALSE, FALSE=Show open file dialog, TRUE=lpFileName set to project file
	lpExportDialog						As long				' Handle of mdi child, Save to rc file TRUE/FALSE 
	lpDllProc							As long				' hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM,fHookFun:DWORD
	lpSetPropertyCbo					As long				' Index of selected
	lpAddTab								As long				' hMdiChild,lpFileName
	lpDelTab								As long				' hMdiChild
	lpSelTab								As long				' hMdiChild
	lpUpdateAll							As long				' Command (IDM_FILE_SAVEALLFILES, IDM_FILE_OPENFILE, IDM_FILE_CLOSEFILE, IDM_OPTION_COLORS, IDM_OPTION_FONT, IDM_OPTION_EDIT, WM_PAINT, IDM_FORMAT_SHOWGRID)
	lpGetFileNameFromID				As long				' nProjectFileID
	lpMenuRebuild						As long				' No parameters
	lpUpdateMRU							As long				' No parameters
	lpUpdateResource					As long				' TRUE to export to output, FALSE to update rc file
	lpUpdateStringTable				As long				' TRUE to export to output, FALSE to update rc file
	lpUpdateAccelerator				As long				' TRUE to export to output, FALSE to update rc file
	lpGetProjectFiles					As long				' Update project treeview, TRUE to auto open files
	lpToolBarStatus					As long				' Updates toolbar button status
	lpUpdateLanguage					As long				' TRUE to export to output, FALSE to update rc file
	GetLangString						As Function( _		' lpApp,lpKey,lpStr,nCC
												ByVal lpApp As WString Ptr, _
												ByVal lpKey As WString Ptr, _
												ByVal lpStr As WString Ptr, _
												ByVal nCC As Integer _
												) As BOOL
	lpSetLanguage						As long				' hWin,lpApp,fNoResize
	lpModalDialog						As long				' DialogBoxParam
	lpModelessDialog					As long				' CreateDialogParam
	lpUpdateSizeingRect				As long				' hWin, fReadOnly
	lpSaveEdit							As long				' hMdiCld
	lpSaveDialog						As long				' hMdiCld,FALSE
	lpSaveHexEdit						As long				' hMdiCld
	lpSetTextLink						As long				' nType (1-3)
	lpScanWord							As long				' lpWord, lpLine
	lpAddWordToWordList				As long				' nType,nOwner,pWords,nParts
end type

' Structure pointed to on return from RAAIM_GETDATA
type RA2ADDINDATA field=1
	nRadASMVer							As long				' Version
	fMaximized							As long				' If TRUE top menu popups+1
	lpIniFile							As ZString Ptr		' Pointer to radasm.ini file
	lpProject							As ZString Ptr		' Pointer to project file
	lpProjectPath						As ZString Ptr		' Pointer to project path. Includes ending '\'
	lpFile								As ZString Ptr		' Pointer to FileName buffer
	lpApp									As ZString Ptr		' Pointer to App path
	lpBin									As ZString Ptr		' Pointer to Binary path
	lpAddIn								As ZString Ptr		' Pointer to AddIn path
	lpHlp									As ZString Ptr		' Pointer to Help path
	lpIncl								As ZString Ptr		' Pointer to Include path
	lpLib									As ZString Ptr		' Pointer to Library path
	lpPro									As ZString Ptr		' Pointer to Projects path
	lpSnp									As ZString Ptr		' Pointer to Snipplets path
	lpTpl									As ZString Ptr		' Pointer to Templates path
	lpMac									As ZString Ptr		' Pointer to Keyboard Macro path
	lpIniAsmFile						As ZString Ptr		' Pointer to masm/fasm/tasm ini file
	fProject								As long				' If TRUE a project is loaded
	lpLoadPath							As ZString Ptr		' Pointer to path where radasm was loaded
	lpCtlTypes							As long				' Pointer to TYPES struct (dialog edit)
	fResChanged							As long				' If TRUE resources are changed since last compile
	lpBreakPoint						As long				' Pointer to 256 breakpoint structs
	fResProject							As long				' If TRUE project has resource file.
	lpBreakPointVar					As long				' Pointer to breakpoint variables
	AsmFlag								As long				' If TRUE dblclicks in output window opens file.
	lpCharTab							As long				' Pointer to RAEdit's character table
	szAssembler(16)					As ubyte				' Fixed lenght string
	lpPrpCboItems						As long				' Comma separated string containing property combo items
	fEditMax								As long				' If TRUE open mdi child maximized
	lpProjectFiles						As long				' Pointer to memory block containing project files
	hWordList							As long				' Handle of wordlist memory
	lpWordList							As long				' Pointer to wordlist memory
	rpProjectWordList					As long				' Relative pointer into lpWordList, points to project code properties
	rpWordListPos						As long				' Relative pointer into lpWordList, points to free
	lpAddins								As long				' Pointer to addins structure
	rpStructList						As long				' Relative pointer into lpWordList, points to structures
	lpszAppName							As ZString Ptr		' Pointer to AppName string
	lpDbg									As ZString Ptr		' Pointer to Debug path
	lpCurPro								As ZString Ptr		' Pointer to Current Project path
	lpszAclKeys							As long				' Pointer to accelerator definitions
	UserBtnID							As long				' Pointer to first user button ID
	nAsm									As long				' Current assembler(nMASM, nTASM....)
	fNT									As long				' TRUE if on NT platform
	lpRABlockdef						As long				' Pointer to block defs
	TabSize								As long				' Number of space chars in a tab char
	ShowApiList							As long				' If TRUE RadASM will show listbox on api's and procs.
	ShowApiStruct						As long				' If TRUE RadASM will show listbox on structure items.
	ShowApiToolTip						As long				' If TRUE RadASM will show tooltip on api's and procs.
	fLB									As long				' RadASM is showing the listbox.
	fTlt									As long				' RadASM is showing the tooltip.
end type

' Addin options
type RA2ADDINOPT field=1
	lpStr									As string ptr		' Pointer to description string
	nAnd									As long				' AND value
	nOr									As long				' OR value
end type

' Return a pointer to a struct like this from InstallDllEx
type RA2ADDINHOOKS field=1
	fHook1 								As long				' Returned hooks 0 to 31
	fHook2 								As long				' Returned hooks 32 to 63
	fHook3 								As long				' Returned hooks 64 to 95
end type

