#Include Once "windows.bi"
#Include Once "win/richedit.bi"

#Include Once "RAEdit.bi"
#Include Once "RAHexEd.bi"
#Include Once "RAGrid.bi"
#Include Once "RACodeComplete.bi"
#Include Once "RAFile.bi"
#Include Once "RAProject.bi"
#Include Once "RAProperty.bi"
#Include Once "RAResEd.bi"
#Include Once "RATools.bi"

' Mdi child editor types
#define RA3ID_EDITCODE							1
#define RA3ID_EDITTEXT							2
#define RA3ID_EDITHEX							3
#define RA3ID_EDITRES							4
#define RA3ID_EDITUSER							5
#define RA3ID_PROJECT							6
#define RA3ID_EXTERNAL							7

' Mdi child ID's
#define RA3ID_FIRSTCHILD						65001
#define RA3ID_LASTCHILD							65499

' Code complete types
#define RA3CCTYPE_NONE							0
#define RA3CCTYPE_PROC							1
#define RA3CCTYPE_TOOLTIP						2
#define RA3CCTYPE_CONST							3
#define RA3CCTYPE_ALL							4
#define RA3CCTYPE_STRUCT						5
#define RA3CCTYPE_USER							6
#define RA3CCTYPE_USERTOOLTIP					7

' RadASM resource ID's
' Res\RadASMAcl.rc
#define RA3IDA_ACCEL								100
#define RA3IDB_MNUARROW							32101

' RadASM.mnu
#define RA3IDR_MENU								10000
#define RA3IDM_FILE								10001
#define RA3IDM_FILE_NEW							10002
#define RA3IDM_FILE_OPEN						10006
#define RA3IDM_FILE_OPENHEX					10060
#define RA3IDM_FILE_REOPEN						10062
#define RA3IDM_FILE_CLOSE						10055
#define RA3IDM_FILE_SAVE						10007
#define RA3IDM_FILE_SAVEAS						10061
#define RA3IDM_FILE_SAVEALL					10008
#define RA3IDM_FILE_PAGESETUP					10056
#define RA3IDM_FILE_PRINT						10010
#define RA3IDM_FILE_RECENTFILES				10179
#define RA3IDM_FILE_RECENTPROJECTS			10180
#define RA3IDM_FILE_EXIT						10004
#define RA3IDM_EDIT								10011
#define RA3IDM_EDIT_UNDO						10019
#define RA3IDM_EDIT_REDO						10020
#define RA3IDM_EDIT_CUT							10012
#define RA3IDM_EDIT_COPY						10013
#define RA3IDM_EDIT_PASTE						10014
#define RA3IDM_EDIT_DELETE						10015
#define RA3IDM_EDIT_SELECTALL					10059
#define RA3IDM_EDIT_FIND						10017
#define RA3IDM_EDIT_FINDNEXT					10169
#define RA3IDM_EDIT_FINDPREV					10170
#define RA3IDM_EDIT_REPLACE					10018
#define RA3IDM_EDIT_GOTODECLARE				10172
#define RA3IDM_EDIT_RETURN						10173
#define RA3IDM_EDIT_GOTOLINE					10199
#define RA3IDM_EDIT_BLOCK						10022
#define RA3IDM_EDIT_INDENT						10028
#define RA3IDM_EDIT_OUTDENT					10029
#define RA3IDM_EDIT_COMMENT					10030
#define RA3IDM_EDIT_UNCOMMENT					10031
#define RA3IDM_EDIT_UPPERCASE					10188
#define RA3IDM_EDIT_LOWERCASE					10189
#define RA3IDM_EDIT_TOSPACES					10191
#define RA3IDM_EDIT_TOTABS						10192
#define RA3IDM_EDIT_TRIM						10190
#define RA3IDM_EDIT_BLOCKMODE					10185
#define RA3IDM_EDIT_BLOCKINSERT				10186
#define RA3IDM_EDIT_BOKKMARK					10023
#define RA3IDM_EDIT_TOGGLEBM					10024
#define RA3IDM_EDIT_NEXTBM						10025
#define RA3IDM_EDIT_PREVBM						10026
#define RA3IDM_EDIT_CLEARBM					10027
#define RA3IDM_EDIT_ERROR						10193
#define RA3IDM_EDIT_NEXTERROR					10194
#define RA3IDM_EDIT_CLEARERRORS				10195
#define RA3IDM_EDIT_OPENINCLUE				10200
#define RA3IDM_VIEW								10032
#define RA3IDM_VIEW_TOOLBAR					10046
#define RA3IDM_VIEW_LOCK						10063
#define RA3IDM_VIEW_TBFILE						10049
#define RA3IDM_VIEW_TBEDIT						10050
#define RA3IDM_VIEW_TBBOOKMARK				10053
#define RA3IDM_VIEW_TBVIEW						10051
#define RA3IDM_VIEW_TBMAKE						10052
#define RA3IDM_VIEW_TBBUILD					10054
#define RA3IDM_VIEW_STATUSBAR					10033
#define RA3IDM_VIEW_PROJECT					10047
#define RA3IDM_VIEW_PROPERTIES				10048
#define RA3IDM_VIEW_OUTPUT						10034
#define RA3IDM_VIEW_TAB							10035
#define RA3IDM_FORMAT							10041
#define RA3IDM_FORMAT_LOCK						10070
#define RA3IDM_FORMAT_FRONT					10071
#define RA3IDM_FORMAT_BACK						10072
#define RA3IDM_FORMAT_SHOW						10073
#define RA3IDM_FORMAT_SNAP						10074
#define RA3IDM_FORMAT_ALIGN					10076
#define RA3IDM_FORMAT_ALIGNLEFT				10080
#define RA3IDM_FORMAT_ALIGNCENTER			10081
#define RA3IDM_FORMAT_ALIGNRIGHT				10082
#define RA3IDM_FORMAT_ALIGNTOP				10084
#define RA3IDM_FORMAT_ALIGNMIDDLE			10085
#define RA3IDM_FORMAT_ALIGNBOTTOM			10086
#define RA3IDM_FORMAT_SIZE						10077
#define RA3IDM_FORMAT_SIZEWIDTH				10087
#define RA3IDM_FORMAT_SIZEHEIGHT				10088
#define RA3IDM_FORMAT_SIZEBOTH				10089
#define RA3IDM_FORMAT_CENTER					10078
#define RA3IDM_FORMAT_CENTERHORIZONTAL		10090
#define RA3IDM_FORMAT_CENTERVERTICAL		10091
#define RA3IDM_FORMAT_INDEX					10079
#define RA3IDM_PROJECT							10042
#define RA3IDM_PROJECT_NEW						10066
#define RA3IDM_PROJECT_OPEN					10067
#define RA3IDM_PROJECT_CLOSE					10068
#define RA3IDM_PROJECT_ADD						10092
#define RA3IDM_PROJECT_ADDNEWFILE			10094
#define RA3IDM_PROJET_ADDEXISTING			10095
#define RA3IDM_PROJECT_ADDOPEN				10096
#define RA3IDM_PROJECT_ADDALLOPEN			10097
#define RA3IDM_PROJECT_ADDGROUP				10098
#define RA3IDM_PROJECT_REMOVE					10093
#define RA3IDM_PROJECT_REMOVEFILE			10101
#define RA3IDM_PROJECT_REMOVEGROUP			10102
#define RA3IDM_PROJECT_EDIT					10150
#define RA3IDM_PROJECT_EDITFILE				10165
#define RA3IDM_PROJECT_EDITGROUP				10164
#define RA3IDM_PROJECT_OPENITEM				10166
#define RA3IDM_PROJECT_OPENITEMFILE			10167
#define RA3IDM_PROJECT_OPENITEMGROUP		10168
#define RA3IDM_PROJECT_OPTION					10103
#define RA3IDM_PROJECTTEMPLATE				10196
#define RA3IDM_PROJECT_LANGUAGE				10197
#define RA3IDM_RESOURCE							10065
#define RA3IDM_RESOURCE_ADD					10108
#define RA3IDM_RESOURCE_ADDDIALOG			10109
#define RA3IDM_RESOURCE_ADDMENU				10110
#define RA3IDM_RESOURCE_ADDACCELERATOR		10111
#define RA3IDM_RESOURCE_ADDVERSION			10112
#define RA3IDM_RESOURCE_ADDSTRING			10113
#define RA3IDM_RESOURCE_ADDMANIFEST			10114
#define RA3IDM_RESOURCE_ADDRCDATA			10115
#define RA3IDM_RESOURCE_ADDTOLBAR			10116
#define RA3IDM_RESOURCE_LANGUAGE				10117
#define RA3IDM_RESOURCE_INCLUDE				10118
#define RA3IDM_RESOURCE_RESOURCE				10119
#define RA3IDM_RESOURCE_NAMES					10120
#define RA3IDM_RESOURCE_EXPORT				10121
#define RA3IDM_RESOURCE_REMOVE				10123
#define RA3IDM_RESOURCE_UNDO					10124
#define RA3IDM_MAKE								10036
#define RA3IDM_MAKE_COMPILE					10104
#define RA3IDM_MAKE_ASSEMBLE					10037
#define RA3IDM_MAKE_MODULES					10141
#define RA3IDM_MAKE_LINK						10107
#define RA3IDM_MAKE_BUILD						10038
#define RA3IDM_MAKE_GO							10040
#define RA3IDM_MAKE_RUN							10039
#define RA3IDM_MAKE_DEBUG						10140
#define RA3IDM_MAKE_TOGGLEMAIN				10177
#define RA3IDM_MAKE_TOGGLEMODULE				10178
#define RA3IDM_DEBUG								10125
#define RA3IDM_DEBUG_TOGGLE					10128
#define RA3IDM_DEBUG_CLEAR						10129
#define RA3IDM_DEBUG_RUN						10131
#define RA3IDM_DEBUG_BREAK						10132
#define RA3IDM_DEBUG_STOP						10133
#define RA3IDM_DEBUG_INTO						10135
#define RA3IDM_DEBUG_OVER						10136
#define RA3IDM_DEBUG_CARET						10137
#define RA3IDM_DEBUG_NODEBUG					10139
#define RA3IDM_TOOLS								10043
#define RA3IDM_TOOLS_SNIPLETS					10174
#define RA3IDM_WINDOW							10005
#define RA3IDM_WINDOW_CLOSE					10055
#define RA3IDM_WINDOW_CLOSEALL				10151
#define RA3IDM_WINDOW_CLOSEALLBUT			10152
#define RA3IDM_WINDOW_HORIZONTAL				10142
#define RA3IDM_WINDOW_VERTICAL				10143
#define RA3IDM_WIDDOW_CASCADE					10144
#define RA3IDM_WINDOW_ICONS					10145
#define RA3IDM_WINDOW_MAXIMIZE				10147
#define RA3IDM_WINDOW_RESTORE					10148
#define RA3IDM_WINDOW_MINIMIZE				10149
#define RA3IDM_OPTION							10044
#define RA3IDM_OPTION_PROGLANG				10198
#define RA3IDM_OPTION_CODE						10154
#define RA3IDM_OPTION_RESOURCE				10155
#define RA3IDM_OPTION_ENVIRONMENT			10156
#define RA3IDM_OPTION_MAKE						10182
#define RA3IDM_OPTION_EXTERNAL				10158
#define RA3IDM_OPTION_ADDIN					10157
#define RA3IDM_OPTION_TOOLS					10160
#define RA3IDM_OPTION_HELP						10161
#define RA3IDM_OPTION_F1						10183
#define RA3IDM_HELP								10045
#define RA3IDM_HELP_ABOUT						10162

#define RA3IDM_FILE_RECENTFILESSTART		12000
#define RA3IDM_FILE_RECENTPROJECTSSTART	12100
#define RA3IDM_TOOLS_START						12200
#define RA3IDM_HELP_START						12300
#define RA3IDM_HELPF1							12400
#define RA3IDM_PROJECT_LANGUAGE_START		12500

' Context.mnu
#define RA3IDR_CONTEXTMENU						11000
#define RA3IDCM_RESOURCE						11001
#define RA3IDCM_FILE								11005
#define RA3IDCM_FILE_OPEN						11014
#define RA3IDCM_FILE_EXPLORE					11019
#define RA3IDCM_FILE_TOCODE					11018
#define RA3IDCM_PROJECT							11006
#define RA3IDCM_PROPERTY						11008
#define RA3IDM_PROPERTY_GOTO					11025
#define RA3IDM_PROPERTY_COPY					11026
#define RA3IDM_PROPERTY_PROTO					11027
#define RA3IDCM_OUTPUT							11009
#define RA3IDM_OUTPUT_HIDE						11020
#define RA3IDM_OUTPUT_CLEAR					11024
#define RA3IDM_OUTPUT_CUT						11023
#define RA3IDM_OUTPUT_COPY						11022

' Messages to RadASM's main window
#define RA3AIM_GETHANDLES						WM_USER+50					' Returns a poiner to a struct containing all useful handles. See ADDINHANDLES structure below.
#define RA3AIM_GETPROCS							WM_USER+51					' Returns a poiner to a struct containing some procs in RadASM. See ADDINPROCS structure below.
#define RA3AIM_GETDATA							WM_USER+52					' Returns a poiner to a struct comtaining data pointers. See ADDINDATA structure below.
#define RA3AIM_GETMENUID						WM_USER+53					' Returns a free menu id. If you need more than one, wParam contains the number of id's to reserve.

' Messages sendt to addins
#define RA3AIM_ADDINSLOADED					WM_USER+100					' This message is sendt to the addins after all addins are loaded. hWin=Main window, wParam=0, lParam=0
#define RA3AIM_COMMAND							WM_USER+101					' This message is sendt to the addins when user makes a menu selection or clicks a toolbar button. hWin=Main window, wParam and lParam as for WM_COMMAND
#define RA3AIM_CLOSE								WM_USER+102					' RadASM requests closing. Return TRUE to prevent RadASM from closing. hWin=Main window, wParam and lParam as for WM_CLOSE
#define RA3AIM_DESTROY							WM_USER+103					' RadASM is about to be destroyed. Now is the time to free memory and resources that your addin allocated. Always return FALSE. hWin=Main window, wParam and lParam as for WM_DESTROY
#define RA3AIM_MENUUPDATE						WM_USER+104					' RadASM has updated its menues. Now is the time to add menu items. Always return FALSE. hWin=Main window, wParam=hMnu, lParam=hContextMnu. NOTE: This command can be sendt more than once. Do not allocate MenuID's here
#define RA3AIM_FILEOPEN							WM_USER+105					' A file is about to be opened. Return TRUE to prevent RadASM from opening the file. hWin=Main window, wParam=ID_EDITCODE, ID_EDITTEXT, ID_EDITHEX, ID_EDITRES or ID_PROJECT, lParam=lpFileName
#define RA3AIM_FILEOPENED						WM_USER+106					' A file has ben opened.. Always return FALSE. hWin=Main window, wParam=ID_EDITCODE, ID_EDITTEXT, ID_EDITHEX, ID_EDITRES or ID_PROJECT, lParam=lpFileName
#define RA3AIM_FILECLOSE						WM_USER+107					' A file is about to be closed.. Return TRUE to prevent RadASM from closing the file. hWin=Mdi child window, wParam=ID_EDITCODE, ID_EDITTEXT, ID_EDITHEX or ID_EDITRES, lParam=lpFileName
#define RA3AIM_FILECLOSED						WM_USER+108					' A file has been closed.. Always return FALSE. hWin=Mdi child window, wParam=ID_EDITCODE, ID_EDITTEXT, ID_EDITHEX or ID_EDITRES, lParam=lpFileName
#define RA3AIM_FILESAVE							WM_USER+109					' A file is about to be saved. Return TRUE to prevent RadASM from saving the file. hWin=Mdi child window, wParam=ID_EDITCODE, ID_EDITTEXT, ID_EDITHEX, ID_EDITRES or ID_EDITUSER, lParam=lpFileName
#define RA3AIM_FILESAVEAS						WM_USER+110					' A file is about to be saved with a new name. Return TRUE to prevent RadASM from saving the file. hWin=Mdi child window, wParam=ID_EDITCODE, ID_EDITTEXT, ID_EDITHEX, ID_EDITRES or ID_EDITUSER, lParam=lpFileName
#define RA3AIM_FILESAVED						WM_USER+111					' A file has been saved. Always return FALSE. hWin=Mdi child window, wParam=ID_EDITCODE, ID_EDITTEXT, ID_EDITHEX, ID_EDITRES or ID_EDITUSER, lParam=lpFileName
#define RA3AIM_GETMODIFY						WM_USER+112					' RadASM requests if a file is changed. Return TRUE if it is your file and it has changed. hWin=Mdi child window, wParam=ID_EDITUSER, lParam=lpFileName
#define RA3AIM_MAKEBEGIN						WM_USER+113					' RadASM starts a make process. Return TRUE to prevent RadASM from running the make process. hWin=Main window, wParam=IDM_MAKE_COMPILE, IDM_MAKE_ASSEMBLE, IDM_MAKE_LINK, IDM_MAKE_BUILD, IDM_MAKE_RUN or IDM_MAKE_GO, lParam=Main file
#define RA3AIM_MAKEDONE							WM_USER+114					' RadASM finished the make process. Always return FALSE. hWin=Main window, wParam=IDM_MAKE_COMPILE, IDM_MAKE_ASSEMBLE, IDM_MAKE_LINK, IDM_MAKE_BUILD, IDM_MAKE_RUN or IDM_MAKE_GO, lParam=Main file
#define RA3AIM_GETFILETYPE						WM_USER+115					' RadASM requests a filetype. Return ID_EDITUSER if your addin handles the filetype, else return FALSE. hWin=Main window,wParam=0, lParam=lpFileName
#define RA3AIM_FILENAMECHANGED				WM_USER+116					' RadASM has changed a filename. Return TRUE if this is your file, else return FALSE. hWin=Mdi child window,wParam=Old filename, lParam=New filename
#define RA3AIM_MENUENABLE						WM_USER+117					' RadASM requests you to enable / disable your menu items. Always return FALSE. hWin=Main window,wParam=IDM_FILE,IDM_EDIT,IDM_VIEW,IDM_FORMAT,IDM_PROJECT,IDM_RESOURCE,IDM_MAKE,IDM_DEBUG,IDM_TOOLS,IDM_WINDOW,IDM_OPTION or IDM_HELP, lParam=0
#define RA3AIM_RASELCHANGE						WM_USER+118					' This message is sendt when a ID_EDITCODE window has a selection change. Always return FALSE. hWin=Mdi child window,wParam=lpTABMEM,lParam=lpRASELCHANE
#define RA3AIM_MDIACTIVATE						WM_USER+119					' This message is sendt when a mdi child is activated or deactivated. Always return FALSE. hWin=Mdi child window,wParam and lParam as M_MDIACIVATE
#define RA3AIM_PARSEFILE						WM_USER+120					' This message is sendt when RadASM is done parsing a file. Always return FALSE. hWin=Mdi child window or NULL if it is a file.,wParam=nOwner, lParam=Pointer to file data.

' HOOK flags returned in hook1 of HOOK structure
#define RA3AIH_ADDINSLOADED					&h000001
#Define RA3AIH_COMMAND							&h000002
#define RA3AIH_CLOSE								&h000004
#define RA3AIH_DESTROY							&h000008
#define RA3AIH_MENUUPDATE						&h000010
#define RA3AIH_FILEOPEN							&h000020
#define RA3AIH_FILEOPENED						&h000040
#define RA3AIH_FILECLOSE						&h000080
#define RA3AIH_FILECLOSED						&h000100
#define RA3AIH_FILESAVE							&h000200
#define RA3AIH_FILESAVEAS						&h000300
#define RA3AIH_FILESAVED						&h000800
#define RA3AIH_GETMODIFY						&h001000
#define RA3AIH_MAKEBEGIN						&h002000
#define RA3AIH_MAKEDONE							&h004000
#define RA3AIH_GETFILETYPE						&h008000
#define RA3AIH_FILENAMECHANGED				&h010000
#define RA3AIH_MENUENABLE						&h020000
#define RA3AIH_RASELCHANGE						&h040000
#define RA3AIH_MDIACTIVATE						&h080000
#define RA3AIH_PARSEFILE						&h100000

Type RA3HOOK
	hook1												As DWORD						' Combinations of #define RA3AIH_ flags
	hook2												As DWORD						' Not used must be zero
	hook3												As DWORD						' Not used must be zero
	hook4												As DWORD						' Not used must be zero
End Type

Type RA3ADDINHANDLES
	hInstance										As HINSTANCE
	hWnd												As HWND
	hClient											As HWND
	hMdi												As HWND
	hEdt												As HWND
	hMenu												As HMENU
	hContextMenu									As HMENU
	hAccel											As HACCEL
	hIcon												As HICON
	hCursor											As HCURSOR
	hSplitCurV										As HCURSOR
	hSplitCurH										As HCURSOR
	hTool												As HWND
	hToolProject									As HWND
	hTabProject										As HWND
	hFileBrowser									As HWND
	hProjectBrowser								As HWND
	hToolProperties								As HWND
	hProperty										As HWND
	hToolOutput										As HWND
	hTabOutput										As HWND
	hOutput											As HWND
	hImmediate										As HWND
	hToolTab											As HWND
	hTab												As HWND
	hStatus											As HWND
	hReBar											As HWND
	hStcBuild										As HWND
	hCboBuild										As HWND
	hToolDebug										As HWND
	hTabDebug										As HWND
	hREGDebug										As HWND
	hFPUDebug										As HWND
	hMMXDebug										As HWND
	hWATCHDebug										As HWND
	hToolFont										As HFONT
	racf												As RAFONT
	ratf												As RAFONT
	rahf												As HEFONT
	hImlTbr											As HIMAGELIST
	hImlTbrGray										As HIMAGELIST
	hMnuIml											As HIMAGELIST
	hTbrFile											As HWND
	hTbrEdit1										As HWND
	hTbrEdit2										As HWND
	hTbrView											As HWND
	hTbrMake											As HWND
	hDiv1												As HWND
	hDiv2												As HWND
	hCC												As HWND
	hTT												As HWND
	hModeless										As HWND
	hHtmlOcx											As HANDLE
	hFind												As HWND
	hDbgTip											As HWND
End Type

Type RA3ADDINPROCS
	' Opens a file.
	OpenTheFile										As Sub( ByVal lpFileName As ZString Ptr, ByVal fType As DWORD )
	' Selects Output or Immediate. nSel:DWORD (0 or 1)
	SetOutputTab									As Sub( ByVal nSel As DWORD )
	' Shows or hides the output tool. fShow:DWORD (TRUE or FALSE)
	ShowOutput										As Sub( ByVal fShow As DWORD )
	' Outputs a text string to selected output. lpString:DWORD
	TextOutput										As Sub( ByVal lpString As ZString Ptr )
	' Sets the tabs changed state. hWin:HWND,fChanged:DWORD (TRUE or FALSE)
	TabToolSetChanged								As Sub( ByVal hWin As HWND, ByVal fChanged As BOOL )
	' Gets a pointer to TABMEM. hWin:HWND
	TabToolGetMem									As Sub( ByVal hWin As HWND )
	' Adds a new tab. hWin:HWND,lpFileName:DWORD
	TabToolAdd										As Sub( ByVal hWin As HWND, ByVal lpFileName As ZString Ptr )
	' Activates the current tab.
	TabToolActivate								As Sub(  )
	' Changes the filename for current selected tab. hWin:HWND,lpFileName:DWORD
	UpdateFileName									As Sub( ByVal hWin As HWND, ByVal lpFileName As ZString Ptr )
	' Updates the filetime. lpTABMEM:DWORD
	UpdateFileTime									As Sub( ByVal lpTABMEM As DWORD )
	' Loops through all tabs performing selected RA3UAM_ message. lParam:DWORD depends on message.
	UpdateAll										As Function( ByVal nFunction As UINT, ByVal lParam As LPARAM ) As LRESULT
End Type

#Define RA3VIEW_STATUSBAR						1

Type RA3PRNPOS
	margins											As RECT
	pagesize											As Point
	nlinespage										As DWORD
End Type

Type RA3WIN
	x													As DWORD
	y													As DWORD
	wt													As DWORD
	ht													As DWORD
	fmax												As DWORD
	ftopmost											As DWORD
	fcldmax											As DWORD
	fView												As DWORD
	ccwt												As DWORD
	ccht												As DWORD
	ptfind											As Point
	ptgoto											As Point
End Type

' 16+20+12=48
Type RA3RADCOLOR
	kwcol(16)										As DWORD						' Keywords
	racol												As RACOLOR					' RAEdit
	toolback											As DWORD
	tooltext											As DWORD
	dialogback										As DWORD
	dialogtext										As DWORD
	styles											As DWORD
	words												As DWORD
	ccback											As DWORD
	cctext											As DWORD
	ttback											As DWORD
	tttext											As DWORD
	ttapi												As DWORD
	ttsel												As DWORD
End Type

Type RA3THEME
	szname											As ZString * 32
	radcol											As RA3RADCOLOR
End Type

#Define RA3EDTOPT_EXPTAB						&H00000001
#Define RA3EDTOPT_INDENT						&H00000002
#Define RA3EDTOPT_LINEHI						&H00000004
#Define RA3EDTOPT_CMNTHI						&H00000008
#Define RA3EDTOPT_LINENR						&H00000010
#Define RA3EDTOPT_SESSION						&H00000020
#Define RA3EDTOPT_BRACE							&H00000040
#Define RA3EDTOPT_SHOWTIP						&H00000080

Type EDTOPT
	tabsize											As DWORD
	fopt												As DWORD
End Type

#Define RESOPT_LOCK								&H00000001
#Define RESOPT_GRID								&H00000002
#Define RESOPT_SNAP								&H00000004
#Define RESOPT_LINE								&H00000008
#Define RESOPT_HEX								&H00000010
#Define RESOPT_AUTO								&H00000020
#Define RESOPT_TIP								&H00000040

Type RA3CUSTCTRL
	hDll												As HMODULE
	szFileName										As ZString * 128
	szStyleMask										As ZString * 16
End Type

Type RA3RESOPT
	gridx												As DWORD						' Assembler.ini
	gridy												As DWORD						' Assembler.ini
	color												As DWORD						' Assembler.ini
	fopt												As DWORD						' Assembler.ini
	nExport											As DWORD						' Assembler.ini
	szUserExport									As ZString * 64			' Assembler.ini
	szExport											As ZString * 64			' Assembler.ini
	nOutput											As DWORD						' Assembler.ini
	custctrl(32)									As RA3CUSTCTRL
	custstyle(64)									As CUSTSTYLE
	custtype(32)									As RARSTYPE
End Type

Type RA3EXTERNAL
	szprog											As ZString * MAX_PATH
	szfiles											As ZString * 64
End Type

Type RA3MAKE
	szType											As ZString * 128
	szCompileRC										As ZString * 128
	szOutCompileRC									As ZString * 32
	szAssemble										As ZString * 128
	szOutAssemble									As ZString * 32
	szLink											As ZString * 128
	szOutLink										As ZString * 32
	szLib												As ZString * 128
	szOutLib											As ZString * 32
End Type

Type RA3FIND
	fr													As DWORD
	fdir												As DWORD
	fscope											As DWORD
	fres												As DWORD
	fproc												As DWORD
	nfound											As DWORD
	nreplace											As DWORD
	initchrg											As CHARRANGE
	scopechrg										As CHARRANGE
	ft													As FINDTEXTEX
	szfindbuff										As ZString * MAX_PATH
	szreplacebuff									As ZString * MAX_PATH
	repdiff											As DWORD
	szfindhistory									As ZString * 10*256
End Type

Type RA3ADDINDATA
	Version											As DWORD
	lpszVersion										As DWORD
	win												As RA3WIN
	winres											As WINSIZE
	radcolor											As RA3RADCOLOR
	szAppPath										As ZString * MAX_PATH
	szRadASMIni										As ZString * MAX_PATH
	szAssemblerIni									As ZString * MAX_PATH
	szAssemblerPath								As ZString * MAX_PATH
	szProjectFile									As ZString * MAX_PATH
	szProjectPath									As ZString * MAX_PATH
	szDefProjectPath								As ZString * MAX_PATH
	szAssemblers									As ZString * 256
	szAssembler										As ZString * 32
	nAsm												As DWORD
	szFileName										As ZString * MAX_PATH
	szFBPath											As ZString * MAX_PATH
	fProject											As DWORD
	tabinx											As DWORD
	fTimer											As DWORD
	nLastLine										As DWORD
	fChanged											As DWORD
	rabdstr											As ZString * 2048
	rabd(32)											As RABLOCKDEF
	szCmntStart										As ZString * 64
	szCmntEnd										As ZString * 64
	szBraceMatch									As ZString * 64
	cctype											As DWORD
	inprogress										As DWORD
	lpCharTab										As DWORD
	edtopt											As EDTOPT
	resopt											As RA3RESOPT
	fLockToolbar									As DWORD
	szFilter											As ZString * 64
	szCodeFiles										As ZString * 32
	szTextFiles										As ZString * 32
	szHexFiles										As ZString * 32
	szResourceFiles								As ZString * 32
	szProjectFiles									As ZString * 32
	szTplTxt											As ZString * 256
	szTplBin											As ZString * 256
	szCCTrig											As ZString * 128
	szCCInc											As ZString * 32
	szCCLib											As ZString * 32
	external(20)									As RA3EXTERNAL
	szCODEString									As ZString * 64
	szRESString										As ZString * 64
	szTXTString										As ZString * 64
	szANYString										As ZString * 64
	szPROString										As ZString * 64
	szALLString										As ZString * (64*4)
	szTypes											As ZString * 256
	szCompileRC										As ZString * 128
	szCompileRCHelp								As ZString * 128
	szCompileRCHelpKw								As ZString * 128
	szAssemble										As ZString * 128
	szAssembleHelp									As ZString * 128
	szAssembleHelpKw								As ZString * 128
	szLink											As ZString * 128
	szLinkHelp										As ZString * 128
	szLinkHelpKw									As ZString * 128
	szLib												As ZString * 128
	szLibHelp										As ZString * 128
	szLibHelpKw										As ZString * 128
	make(32)											As RA3MAKE
	szMainRC											As ZString * 128
	szMainAsm										As ZString * 128
	szDebug											As ZString * 128
	szCommandLine									As ZString * 128
	fCmdExe											As DWORD
	szCmdExe											As ZString * 64
	szPOApiFiles									As ZString * 256
	fDelMinor										As DWORD
	szMruFiles										As ZString * 10*MAX_PATH
	szMruProjects									As ZString * 10*MAX_PATH
	pHtmlHelpProc									As DWORD
	szHelpF1											As ZString * 3*MAX_PATH
	find												As RA3FIND
	nBackup											As DWORD
	fDebugging										As DWORD
	ti													As TOOLINFO
	fCanDebug										As DWORD
	szDbgFileName									As ZString * MAX_PATH
	szNoDebug										As ZString * 1024*8
	fMainThread										As DWORD
	nErrID											As DWORD
	ErrID(256)										As DWORD
	fNoChangeNotify								As DWORD
	szError											As ZString * 64
	fExternal										As DWORD
	ccchrg											As CHARRANGE
	tti												As TTITEM
	fIncBuild										As DWORD
End Type

Type RA3FILEINFO
	pid												As DWORD
	idparent											As DWORD
	flag												As DWORD
	ID													As DWORD
	rect												As RECT
	nline												As DWORD
	filename											As ZString * MAX_PATH
End Type

Type RA3TABMEM
	hwnd												As HWND						' Handle of the mdi child window.
	hedt												As HWND						' Handle of the edit window
	pid												As DWORD						' Project id
	filename											As ZString * MAX_PATH	' Filename including full path.
	ft													As FILETIME					' Filetime for last write.
	nchange											As DWORD
	fchanged											As DWORD
	fupdate											As DWORD
	fnonotify										As DWORD
	nlastsize										As DWORD
	nlastpropline									As DWORD
End Type

' Messages to the UpdateAll proc
#Define RA3UAM_ISOPEN							1
#Define RA3UAM_ISOPENACTIVATE					2
#Define RA3UAM_ISRESOPEN						3
#Define RA3UAM_SAVEALL							4
#Define RA3UAM_CLOSEALL							5
#Define RA3UAM_SETCOLORS						6
#Define RA3UAM_SETFONTS							7
#Define RA3UAM_PARSE								8
#Define RA3UAM_ANYBOOKMARKS					9
#Define RA3UAM_CLEARBOOKMARKS					10
#Define RA3UAM_ANYBREAKPOINTS					11
#Define RA3UAM_CLEARBREAKPOINTS				12
#Define RA3UAM_CLEARERRORS						13
#Define RA3UAM_FINDERROR						14
#Define RA3UAM_UNSAVED_SOURCE_FILES			15
#Define RA3UAM_NEWER_SOURCE_FILES			16
#Define RA3UAM_SET_BREAKPOINTS				17
#Define RA3UAM_LOCK_SOURCE_FILES				18
#Define RA3UAM_UNLOCK_SOURCE_FILES			19
#Define RA3UAM_IS_CHANGED						20
#Define RA3UAM_CLEAR_CHANGED					21
