#Define ADDIN_NAME								"ProjPub"

' Project Publisher options that can be disabled
#Define PROJPUB_FEATURES_REMDRVINST			1 Shl 0
#Define PROJPUB_FEATURES_SHORTCUTS			1 Shl 1
#Define PROJPUB_FEATURES_FILEASSOC			1 Shl 2
#Define PROJPUB_FEATURES_RUNONFINISH		1 Shl 3
#Define PROJPUB_FEATURES_OPENWITH			1 Shl 4

' FbEdit menu items
#Define IDM_FBEMAKE								10141
#Define IDM_FBEOPTIONS							10161

' RadASM 2.x menu items
#Define IDM_RA2MAKE								49905
#Define IDM_RA2OPTIONS							49908

' Supported IDE's
#Define IDE_FBEDIT								0
#Define IDE_RADASM2								1
#Define IDE_RADASM3								2
#Define IDE_MASMEDIT								3

Type ProjPub_File
	Name As ZString Ptr
	Next As ProjPub_File Ptr
End Type

Type ProjPub_Folder
	Name As ZString Ptr
	Next As ProjPub_Folder Ptr
	File As ProjPub_File
End Type

Type ProjPub_Lang
	Name As ZString Ptr
	FileName As ZString Ptr
	Next As ProjPub_Lang Ptr
End Type

Type ProjPub_FileTypeContextMenu
	Verb As ZString Ptr
	ItemText As ZString Ptr
	Command As ZString Ptr
	Next As ProjPub_FileTypeContextMenu Ptr
End Type

Type ProjPub_FileType
	Ext As ZString Ptr
	AppIDKey As ZString Ptr
	Description As ZString Ptr
	DefaultIcon As ZString Ptr
	Next As ProjPub_FileType Ptr
	ContextMenu As ProjPub_FileTypeContextMenu
End Type

#Define PROJPUB_WIZPAGES_END					PROJPUB_WIZPAGES-1

Common Shared hInstance As HINSTANCE

Common Shared CurIDE As Integer
Common Shared IDEPath As ZString * MAX_PATH+1
Common Shared CurProjectFile As ZString * MAX_PATH+1
Common Shared CurProjectPath As ZString * MAX_PATH+1

' FbEdit IDE Variables
Common Shared FbEHooks As FBEADDINHOOKS
Common Shared lpFbEHandles As FBEADDINHANDLES Ptr
Common Shared lpFbEFunctions As FBEADDINFUNCTIONS Ptr
Common Shared lpFbEData As FBEADDINDATA Ptr

' RadASM 2.x IDE Variables
Common Shared Ra2Hooks As RA2ADDINHOOKS
Common Shared lpRa2Handles As RA2ADDINHANDLES Ptr
Common Shared lpRa2Functions As RA2ADDINPROCS Ptr
Common Shared lpRa2Data As RA2ADDINDATA Ptr

' RadASM 3.x IDE Variables
Common Shared Ra3Hooks As RA3HOOK
Common Shared lpRa3Handles As RA3ADDINHANDLES Ptr
Common Shared lpRa3Functions As RA3ADDINPROCS Ptr
Common Shared lpRa3Data As RA3ADDINDATA Ptr

' MasmEdit IDE Variables
Common Shared MeHooks As MEHOOK
Common Shared lpMeHandles As MEADDINHANDLES Ptr
Common Shared lpMeFunctions As MEADDINPROCS Ptr
Common Shared lpMeData As MEADDINDATA Ptr

Common Shared WelcomeMsgFont As HFONT
Common Shared HeaderTitleFont As HFONT
Common Shared hDC As HDC

Common Shared IDM_PUBLISH As Unsigned Integer
Common Shared IDM_PUBLISHOPTIONS As Unsigned Integer
Common Shared MakeSubMenu As HMENU

Common Shared buffer As ZString * MAX_PATH+1

Common Shared DisabledFeatures As Integer
Common Shared LastPublishResult As Integer

Declare Sub DisableUnneededFeatures(  )
Declare Function GetTranslateString( ByRef KeyName As Const String, ByRef KeyValueDefault As Const String ) As String
Declare Sub TranslateAddinDialog( ByVal hWin As HWND )
Declare Sub AddAccelerator( ByVal fvirt As Integer, ByVal akey As Integer, ByVal id As Integer )
Declare Function OpenFileName( ByVal hWin As HWND, ByVal lpszTitle As ZString Ptr, ByVal lpszInitialDir As ZString Ptr, ByVal lpszFilter As ZString Ptr ) As String
Declare Function EnableDlgItem( ByVal hWin As HWND, ByVal nIDDlgItem As Integer, ByVal bEnable As BOOL ) As BOOL
Declare Function Replace( ByRef InputString As Const String, ByRef SearchString As Const String, ByRef Replacement As Const String ) As String
Declare Function EscapeNSIS( ByRef UnescapedStr As Const String ) As String
Declare Function FilterNSISIdentifier( ByRef NSISIdentifier As Const String ) As String
