/'
 ' Project Publisher - Installer Creator Addin for FbEdit, RadASM and MasmEdit
 '
 ' Copyright (C) 2010 Arnel A. Borja (Galeon)
 '
 ' This program is free software: you can redistribute it and/or modify it under 
 ' the terms of the GNU General Public License as published by the Free Software 
 ' Foundation, either version 3 of the License, or (at your option) any later 
 ' version.
 '
 ' This program is distributed in the hope that it will be useful, but WITHOUT 
 ' ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 ' FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more 
 ' details.
 '
 ' You should have received a copy of the GNU General Public License along with 
 ' this program.  If not, see <http://www.gnu.org/licenses/>.
 '
 '/

#Include Once "windows.bi"
#Include Once "win/commctrl.bi"
#Include Once "win/shellapi.bi"

#Include Once "Inc/FbEdit.bi"
#Include Once "Inc/RadASM2.bi"
#Include Once "Inc/RadASM3.bi"
#Include Once "Inc/MasmEd.bi"

#Include Once "ProjPub.bi"
#Include Once "Settings.bi"
#Include Once "Help.bi"
#Include Once "Welcome.bi"
#Include Once "Resource.bi"

Function WelcomeDialogProc( _
	ByVal hWin As HWND, _
	ByVal uMsg As UINT, _
	ByVal wParam As WPARAM, _
	ByVal lParam As LPARAM _
	) As BOOL

	Select Case uMsg
		Case WM_INITDIALOG
			Dim lf As LOGFONT
			Dim hDC As HDC

			' Translate dialog box
			TranslateAddinDialog( hWin )

			If WelcomeMsgFont = NULL Then
				' Create font for Welcome/Finish/Failed message static controls
				WelcomeMsgFont = Cast( HFONT, SendMessage( hWin, WM_GETFONT, 0, 0 ) )
				GetObject( WelcomeMsgFont, SizeOf( LOGFONT ), @lf )
				hDC = GetDC( hWin )
				lf.lfHeight = -MulDiv( 14, GetDeviceCaps( hDC, LOGPIXELSY ), 72 )
				lf.lfWidth = 0
				lf.lfWeight = FW_BOLD
				ReleaseDC( hWin, hDC )
				WelcomeMsgFont=CreateFontIndirect( @lf )
			End If

			If HeaderTitleFont = NULL Then
				' Create font for Header Title static controls
				HeaderTitleFont = Cast( HFONT, SendMessage( hWin, WM_GETFONT, 0, 0 ) )
				GetObject( HeaderTitleFont, SizeOf( LOGFONT ), @lf )
				lf.lfWeight = FW_BOLD
				HeaderTitleFont=CreateFontIndirect( @lf )
			End If

			' Change Welcome/Finish/Failed message static controls font
			SendDlgItemMessage( hWin, IDC_STCWELCOME, WM_SETFONT, Cast( WPARAM, WelcomeMsgFont), MAKELPARAM( TRUE, 0 ) )
			'
		Case WM_COMMAND
			'
		Case WM_CLOSE
			DestroyWindow( hWin )
			'
		Case WM_NOTIFY
			Select Case Cast( NMHDR Ptr, lParam )->code
				Case PSN_SETACTIVE
					PropSheet_SetWizButtons( Cast( NMHDR Ptr, lParam )->hwndFrom, PSWIZB_NEXT )
					'
			End Select
			'
		Case WM_HELP
			ShowContextHelp( Cast( HELPINFO Ptr, lParam ) )
			'
		Case Else
			Return FALSE
			'
	End Select

	Return TRUE

End Function

