/'
 ' Project Publisher - Installer Creator Addin for FbEdit, RadASM and MasmEdit
 '
 ' Copyright (C) 2010 Arnel A. Borja (Galeon)
 '
 ' This program is free software: you can redistribute it and/or modify it under 
 ' the terms of the GNU General Public License as published by the Free Software 
 ' Foundation, either version 3 of the License, or (at your option) any later 
 ' version.
 '
 ' This program is distributed in the hope that it will be useful, but WITHOUT 
 ' ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 ' FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more 
 ' details.
 '
 ' You should have received a copy of the GNU General Public License along with 
 ' this program.  If not, see <http://www.gnu.org/licenses/>.
 '
 '/

#Include Once "windows.bi"
#Include Once "win/commctrl.bi"
#Include Once "win/commdlg.bi"
#Include Once "win/shellapi.bi"

#Include Once "Inc/FbEdit.bi"
#Include Once "Inc/RadASM2.bi"
#Include Once "Inc/RadASM3.bi"
#Include Once "Inc/MasmEd.bi"

#Include Once "ProjPub.bi"
#Include Once "Wizard.bi"
#Include Once "Settings.bi"
#Include Once "Welcome.bi"
#Include Once "ProjType.bi"
#Include Once "ProjInfo.bi"
#Include Once "ProjWeb.bi"
#Include Once "License.bi"
#Include Once "MultiUser.bi"
#Include Once "InstallFolder.bi"
#Include Once "Files.bi"
#Include Once "Mui.bi"
#Include Once "RemDrvInst.bi"
#Include Once "Shortcuts.bi"
#Include Once "LangDll.bi"
#Include Once "FileAssoc.bi"
#Include Once "OpenWith.bi"
#Include Once "Uninst.bi"
#Include Once "Compressor.bi"
#Include Once "Preview.bi"
#Include Once "Publish.bi"
#Include Once "Finish.bi"
#Include Once "Failed.bi"
#Include Once "Resource.bi"

' This will show the Project Publish Wizard
Sub ShowProjectPublishWizard ( _
	ByVal hwndOwner As HWND _
	)

   Dim As PROPSHEETPAGE psp(0 To PROJPUB_WIZPAGES_END)
   Dim As PROPSHEETHEADER psh

   With psp(PROJPUB_WIZPAGE_WELCOME)
		.dwSize = SizeOf( PROPSHEETPAGE )
		.hInstance = hInstance
		.pszTemplate = MAKEINTRESOURCE(IDD_DLGWELCOME)
		.pfnDlgProc = @WelcomeDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_PROJTYPE)
		.dwSize = SizeOf( PROPSHEETPAGE )
		.hInstance = hInstance
		.pszTemplate = MAKEINTRESOURCE(IDD_DLGPROJTYPE)
		.pfnDlgProc = @ProjTypeDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_PROJINFO)
		.dwSize = SizeOf( PROPSHEETPAGE )
		.hInstance = hInstance
		.pszTemplate = MAKEINTRESOURCE(IDD_DLGPROJINFO)
		.pfnDlgProc = @ProjInfoDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_PROJWEB)
		.dwSize = SizeOf( PROPSHEETPAGE )
		.hInstance = hInstance
		.pszTemplate = MAKEINTRESOURCE(IDD_DLGPROJWEB)
		.pfnDlgProc = @ProjWebDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_LICENSE)
		.dwSize = SizeOf( PROPSHEETPAGE )
		.hInstance = hInstance
		.pszTemplate = MAKEINTRESOURCE(IDD_DLGLICENSE)
		.pfnDlgProc = @LicenseDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_MULTIUSER)
		.dwSize = SizeOf( PROPSHEETPAGE )
		.hInstance = hInstance
		.pszTemplate = MAKEINTRESOURCE(IDD_DLGMULTIUSER)
		.pfnDlgProc = @MultiUserDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_INSTALLFOLDER)
		.dwSize = SizeOf( PROPSHEETPAGE )
		.hInstance = hInstance
		.pszTemplate = MAKEINTRESOURCE(IDD_DLGINSTFOLDER)
		.pfnDlgProc = @InstallFolderDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_FILES)
		.dwSize = SizeOf( PROPSHEETPAGE )
		.hInstance = hInstance
		.pszTemplate = MAKEINTRESOURCE(IDD_DLGFILES)
		.pfnDlgProc = @FilesDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_MUI)
		.dwSize = SizeOf( PROPSHEETPAGE )
		.hInstance = hInstance
		.pszTemplate = MAKEINTRESOURCE(IDD_DLGMUI)
		.pfnDlgProc = @MuiDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_REMDRVINST)
		.dwSize = SizeOf( PROPSHEETPAGE )
		.hInstance = hInstance
		.pszTemplate = MAKEINTRESOURCE(IDD_DLGREMDRVINST)
		.pfnDlgProc = @RemDrvInstDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_SHORTCUTS)
		.dwSize = SizeOf( PROPSHEETPAGE )
		.hInstance = hInstance
		.pszTemplate = MAKEINTRESOURCE(IDD_DLGSHORTCUTS)
		.pfnDlgProc = @ShortcutsDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_LANGDLL)
		.dwSize = SizeOf( PROPSHEETPAGE )
		.hInstance = hInstance
		.pszTemplate = MAKEINTRESOURCE(IDD_DLGLANGDLL)
		.pfnDlgProc = @LangDllDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_FILEASSOC)
		.dwSize = SizeOf( PROPSHEETPAGE )
		.hInstance = hInstance
		.pszTemplate = MAKEINTRESOURCE(IDD_DLGFILEASSOC)
		.pfnDlgProc = @FileAssocDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_OPENWITH)
		.dwSize = SizeOf( PROPSHEETPAGE )
		.hInstance = hInstance
		.pszTemplate = MAKEINTRESOURCE(IDD_DLGOPENWITH)
		.pfnDlgProc = @OpenWithDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_UNINST)
		.dwSize = SizeOf( PROPSHEETPAGE )
		.hInstance = hInstance
		.pszTemplate = MAKEINTRESOURCE(IDD_DLGUNINST)
		.pfnDlgProc = @UninstDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_COMPRESSOR)
		.dwSize = SizeOf( PROPSHEETPAGE )
		.hInstance = hInstance
		.pszTemplate = MAKEINTRESOURCE(IDD_DLGCOMPRESSOR)
		.pfnDlgProc = @CompressorDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_PREVIEW)
		.dwSize = SizeOf( PROPSHEETPAGE )
		.hInstance = hInstance
		.pszTemplate = MAKEINTRESOURCE(IDD_DLGPREVIEW)
		.pfnDlgProc = @PreviewDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_PUBLISH)
		.dwSize = SizeOf( PROPSHEETPAGE )
		.hInstance = hInstance
		.pszTemplate = MAKEINTRESOURCE(IDD_DLGPUBLISH)
		.pfnDlgProc = @PublishDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_FINISH)
		.dwSize = SizeOf( PROPSHEETPAGE )
		.hInstance = hInstance
		.pszTemplate = MAKEINTRESOURCE(IDD_DLGFINISH)
		.pfnDlgProc = @FinishDialogProc
   End With

   With psp(PROJPUB_WIZPAGE_FAILED)
		.dwSize = SizeOf( PROPSHEETPAGE )
		.hInstance = hInstance
		.pszTemplate = MAKEINTRESOURCE(IDD_DLGFAILED)
		.pfnDlgProc = @FailedDialogProc
   End With

	' Wizard caption
	buffer = GetTranslateString( "6000", "Project Publish Wizard" )

	psh.dwSize = SizeOf( PROPSHEETHEADER )
	psh.dwFlags = PSH_USEICONID Or PSH_PROPSHEETPAGE Or PSH_WIZARD Or PSH_USECALLBACK
	psh.hwndParent = hwndOwner
	psh.hInstance = hInstance
	psh.pszIcon = MAKEINTRESOURCE(IDI_PROJPUB)
	psh.pszCaption = @buffer
	psh.nPages = PROJPUB_WIZPAGES
	psh.nStartPage = 0
	psh.ppsp = Cast( LPCPROPSHEETPAGE, @psp(0) )
	psh.pfnCallback = @ProjectPublishWizardCallback

	PropertySheet( @psh )

End Sub

Function ProjectPublishWizardCallback ( _
	ByVal hwndDlg As HWND, _
	ByVal uMsg As UINT, _
	ByVal lParam As LPARAM _
	) As Integer

	Select Case uMsg
		Case PSCB_PRECREATE
			Cast( DLGTEMPLATE Ptr, lParam )->style Or= DS_CONTEXTHELP
			'
	End Select

	Return 0

End Function

